#define FILE_NAME "Bingo5.c"

/* ӥ󥴣βžȶӽƤΥѥΩ饤Ȥɽ */
/* Sort() , AddToNvec() , AddToSvec() λ */

#if defined(PDEF_H)

 LIST("# " FILE_NAME " version 7.06")
 FIX(9)
 SVEC(Num,3,FIX9, EJ("Number as string",  "ʸȤƤο"))
 INT(Fold,4,      EJ("Fold number",       "ޤ֤"))
 FIX(5)
 SVEC(Sym,3,FIX5, EJ("Output character",  "ʸ"))
 INT(N,2,         EJ("Number of patterns","ѥ"))
 NVEC(Pattern,4,N,EJ("Patterns",          "ѥ"))
 INT(M,2,         EJ("Output Number",     "Ϸ̤ο"))
 SVEC(SV,0,M,     EJ("Output result",     "Ϸ"))
 PROC(Run,        EJ("Execute function",  "¹Դؿ"))
 AUTO("Limit 1")
 #if JPN
   AUTO("Num")
   AUTO("         $")
  #if defined(__unix__)||(defined(MASM32)&&!WINDOWS__)||INT_MAX<=32767
   AUTO("Fold Sym")
   AUTO("11   FR .  $")
  #else
   AUTO("Fold Sym")
   AUTO("11   FR .  $")
  #endif
 #else
   AUTO("Num")
   AUTO("0 1 2 3 4 5 6 7 8 $")
   AUTO("Fold Sym")
   AUTO("18 + * F ' ' - $")
 #endif
 #if WINDOWS__
   AUTO("Fold")
   AUTO("18")
 #endif
 LAST("Run")
 LAST("Print SV")

#else

 #define NO_OPEN
 #define NO_LIST
 #if !defined(JPN)
  #define JPN 1
 #endif

 #include "pocom.h"
 CHECK_FILE_NAME

char Bf[4][200];

/* 0 1 2    1  2  4
   7   3  128     8
   6 5 4   64 32 16  */
unsigned char Mirror[] =   { 4,2,1,128,64,32,16,8 };
unsigned char Line2[][2] = { {1,16}, {2,32},  {4,64},    {8,128}    };
unsigned char Line3[][3] = { {1,2,4},{4,8,16},{16,32,64},{64,128,1} };

const char*A(Int p,Int s) { return(p&s)?Sym[1]:Sym[0]; }

/* ΩäƤӥåȤο */
nint BitCount(Int p) {
    Int sum=0;
    while (p) { sum++; p&=p-1; }
    return(nint)sum;
}

/* ΩƤ饤ο */
nint LineCount(Int p) {
    Int hits=0; size_t k;
    for (k=0;k<sizeof Line2/sizeof*Line2;k++)
     if ((p&Line2[k][0])&&(p&Line2[k][1])) hits++;
    for (k=0;k<sizeof Line3/sizeof*Line3;k++)
     if ((p&Line3[k][0])&&(p&Line3[k][1])&&(p&Line3[k][2])) hits++;
    return(nint)hits;
}

void AddSV(Int p,Int line,Int bit) {
   sprintf(Bf[0]+strlen(Bf[0]),"%s%s%s%s",Num[line],Sym[4],Num[bit],Sym[3]);
   sprintf(Bf[1]+strlen(Bf[1]),"%s%s%s%s",A(p,  1), A(p, 2),A(p, 4),Sym[3]);
   sprintf(Bf[2]+strlen(Bf[2]),"%s%s%s%s",A(p,128), Sym[2], A(p, 8),Sym[3]);
   sprintf(Bf[3]+strlen(Bf[3]),"%s%s%s%s",A(p, 64), A(p,32),A(p,16),Sym[3]);
}

/* ž */
Int Rotate(Int p,Int s) { return((p>>s)|(p<<(8-s)))&255; }

/* Фʤ true */
bool Covered(Int p) {
    Int i,k;
    for (i=0;i<N;i++) {
       Int old=(Int)(Pattern[i]&255),mirror=0;
       /* žκ */
       for (k=2;k<8;k+=2) if (Rotate(p,k)==old) break;
       if (k<8) break;
       /* κ */
       for (k=0;k<8;k++) if (p&((Int)1<<k)) mirror|=Mirror[k];
       /* Ȥβžκ */
       for (k=0;k<8;k+=2) if (Rotate(mirror,k)==old) break;
       if (k<8) break;
    }
    return(bool)(i<N);
}

void FlushSV(Int i) {
   Int k;
   for (k=0;k<4;k++) AddToSvec(SV,Bf[k]);
   for (k=0;k<4;k++) Bf[k][0]=0;
   if (i<N-1) AddToSvec(SV,"-");
}

void MakeSV(Int i) {
   nint p=Pattern[i]; Int line=(Int)(p>>24),bit=(Int)((p>>16)&15);
   static Int n; n++;
   AddSV((Int)p,line,bit);
   if (n>=Fold||i==N-1) { FlushSV(i); n=0; }
}

void Run(void) {
    Int i;
    for (i=0;i<256;i++) {
       if (Covered(i)) continue;
       AddToNvec(Pattern,(nint)i|(BitCount(i)<<16)|(LineCount(i)<<24));
    }
    Sort("Pattern");
    for (i=0;i<N;i++) MakeSV(i);
    NoList=1;
}

#endif
